searchData={"items":[{"type":"module","title":"ExAequoColors","doc":"","ref":"ExAequoColors.html"},{"type":"module","title":"Features - ExAequoColors","doc":"- ANSI Colors\n\n- Extended ANSI Color, suffixs\n\n- `colorize` CLI","ref":"ExAequoColors.html#module-features"},{"type":"function","title":"ExAequoColors.col/2","doc":"","ref":"ExAequoColors.html#col/2"},{"type":"function","title":"ANSI code for a color to a string - ExAequoColors.col/2","doc":"We can use the 8 basic ANSI color codes\n\n    iex(1)> col(\"This is red\", :red)\n    \"\\e[31mThis is red\"\n\nOr we can add a reset\n\n    iex(2)> col(\"This is red\", :red, :reset)\n    \"\\e[31mThis is red\\e[0m\"\n\nWhich can also be achieved by means of the `colr` function\n\n    iex(3)> colr(\"This is red\", :red)\n    \"\\e[31mThis is red\\e[0m\"\n\nWe can also add bold or dim\n\n    iex(4)> col(\"Bold and blue\", :bold, :blue)\n    \"\\e[1m\\e[34mBold and blue\"\n\n    iex(5)> col(\"Green and dim\", :green, :dim)\n    \"\\e[32m\\e[2mGreen and dim\"","ref":"ExAequoColors.html#col/2-ansi-code-for-a-color-to-a-string"},{"type":"function","title":"ExAequoColors.col/3","doc":"","ref":"ExAequoColors.html#col/3"},{"type":"function","title":"ExAequoColors.colorize/1","doc":"","ref":"ExAequoColors.html#colorize/1"},{"type":"function","title":"ExAequoColors.colorize/2","doc":"Convenience delegation","ref":"ExAequoColors.html#colorize/2"},{"type":"function","title":"ExAequoColors.colr/2","doc":"","ref":"ExAequoColors.html#colr/2"},{"type":"function","title":"ExAequoColors.colr/3","doc":"","ref":"ExAequoColors.html#colr/3"},{"type":"function","title":"ExAequoColors.version/0","doc":"","ref":"ExAequoColors.html#version/0"},{"type":"module","title":"ExAequoColors.Cli.Implementation","doc":"Implements the testable parts for the CLI","ref":"ExAequoColors.Cli.Implementation.html"},{"type":"function","title":"ExAequoColors.Cli.Implementation.main/1","doc":"","ref":"ExAequoColors.Cli.Implementation.html#main/1"},{"type":"module","title":"ExAequoColors.Colorizer","doc":"Backend of the cli","ref":"ExAequoColors.Colorizer.html"},{"type":"function","title":"ExAequoColors.Colorizer.colorize/1","doc":"colorizes a binary according to options\n\n    iex(1)> colorize(\"hello\")\n    \"hello\"\n\n# Default Options, resetting with `$`\n\nHere are the default options, a color is triggered by `<...`\n\n    iex(2)> colorize(\" \")\n    \"\\e[32m\"\n\nWe can also add bold for example\n\n    iex(3)> colorize(\" success\")\n    \"\\e[32m\\e[1msuccess\"\n\nAnd resetting is simply achieved by a `$`\n\n    iex(4)> colorize(\"$\")\n    \"\\e[0m\"\n\nWhich works in both orders, and note that the space after the `,` is not needed, we use \n`$` to reset here!\n\n    iex(5)> colorize(\" highlighted$normal\")\n    \"\\e[1m\\e[33mhighlighted\\e[0mnormal\"\n\nWe can use other color systems, like ANSI 256, also demonstrating how to escape `<` and `$`:\n\n    iex(6)> colorize(\"256 <<$$\")\n    \"256\\e[38;5;21m<$\"\n\nDim, italic and named RGB colors are also at your disposal\n\n    iex(7)> colorize(\" and \")\n    \"\\e[2m\\e[38;2;255;135;135mand\\e[3m\"\n\n# Using different options\n\nMaybe we want to open and close color definitions with the `!` character, note also that,\nin that case we need to double the `!` character, but not the `<` character anymore, to\nget them as verbatim text\n\n    iex(8)> colorize(\"!red!!!<$\", trigger: \"!\", closer: \"!\")\n    \"\\e[31m!<\\e[0m\"\n\n # rgb\n\n  In three decimal numbers....\n\n    iex(9)> colorize(\"<12,255,0>rgb\")\n    \"\\e[38;2;12;255;0mrgb\"\n\n\n  or in hex\n\n    iex(10)> colorize(\"<#0cff00>rgb\")\n    \"\\e[38;2;12;255;0mrgb\"","ref":"ExAequoColors.Colorizer.html#colorize/1"},{"type":"function","title":"ExAequoColors.Colorizer.colorize/2","doc":"","ref":"ExAequoColors.Colorizer.html#colorize/2"},{"type":"function","title":"ExAequoColors.Colorizer.colorize!/3","doc":"Using a map for options and an already provided parser\n\n    iex(11)> parser = make_parser()\n    ...(11)> colorize!(\" \", parser, %{auto: true})\n    {:ok, \"\\e[35m\\e[1m\\e[0m\"}\n\nThis is very useful for meaningful error messages as we can see\nbelow","ref":"ExAequoColors.Colorizer.html#colorize!/3"},{"type":"function","title":"ExAequoColors.Colorizer.colorize_lines/2","doc":"This differs substentially from calling `colorize` with a list as we will report errors with line numbers if applicable\n      \n    iex(12)> colorize_lines([\" BOLD\", \" RED\"])\n    {:ok, [\"\\e[1mBOLD\", \"\\e[31mRED\"]}\n\nIt can also join the lines together\n      \n    iex(13)> colorize_lines([\" BOLD\", \" RED\"], join: true)\n    {:ok, \"\\e[1mBOLD\\n\\e[31mRED\"}\n\nwith a custom joiner and autoreset too\n      \n    iex(14)> colorize_lines([\" BOLD\", \" RED\"], join: \"\", auto: true)\n    {:ok, \"\\e[1mBOLD\\e[0m\\e[31mRED\\e[0m\"}\n\n\nLines can also be a stream\n      \n    iex(15)> lines = [\" BOLD\", \" RED\"] |> Stream.map(&(&1))\n    ...(15)> colorize_lines(lines)\n    {:ok, [\"\\e[1mBOLD\", \"\\e[31mRED\"]}\n\n    colorize_lines()\n    {:ok, [\"\\e[1mBOLD\", \"\\e[31mRED\"]}\n\nbut the nice thing is to tell the user where the error is\n  \n    iex(14)> colorize_lines([\" BOLD\", \"<red\"], join: \"\", auto: true)\n    {:error, \"Illegal color syntax in line 2\"}","ref":"ExAequoColors.Colorizer.html#colorize_lines/2"},{"type":"function","title":"ExAequoColors.Colorizer.make_options/1","doc":"","ref":"ExAequoColors.Colorizer.html#make_options/1"},{"type":"function","title":"ExAequoColors.Colorizer.make_parser/1","doc":"","ref":"ExAequoColors.Colorizer.html#make_parser/1"},{"type":"function","title":"ExAequoColors.Colorizer.make_parser_and_options/1","doc":"","ref":"ExAequoColors.Colorizer.html#make_parser_and_options/1"},{"type":"type","title":"ExAequoColors.Colorizer.atoms/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:atoms/0"},{"type":"type","title":"ExAequoColors.Colorizer.binaries/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:binaries/0"},{"type":"type","title":"ExAequoColors.Colorizer.color_fn_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:color_fn_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.color_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:color_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.either/2","doc":"","ref":"ExAequoColors.Colorizer.html#t:either/2"},{"type":"type","title":"ExAequoColors.Colorizer.error_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:error_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.error_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:error_t/1"},{"type":"type","title":"ExAequoColors.Colorizer.input_source_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:input_source_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.maybe/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:maybe/1"},{"type":"type","title":"ExAequoColors.Colorizer.natural/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:natural/0"},{"type":"type","title":"ExAequoColors.Colorizer.numbered/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:numbered/1"},{"type":"type","title":"ExAequoColors.Colorizer.numbered_line_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:numbered_line_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.numbered_lines_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:numbered_lines_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.ok_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:ok_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.ok_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:ok_t/1"},{"type":"type","title":"ExAequoColors.Colorizer.pair_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:pair_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.pair_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:pair_t/1"},{"type":"type","title":"ExAequoColors.Colorizer.pair_t/2","doc":"","ref":"ExAequoColors.Colorizer.html#t:pair_t/2"},{"type":"type","title":"ExAequoColors.Colorizer.pairs_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:pairs_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.pairs_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:pairs_t/1"},{"type":"type","title":"ExAequoColors.Colorizer.pairs_t/2","doc":"","ref":"ExAequoColors.Colorizer.html#t:pairs_t/2"},{"type":"type","title":"ExAequoColors.Colorizer.parser_fn/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:parser_fn/0"},{"type":"type","title":"ExAequoColors.Colorizer.reducer_result_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:reducer_result_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.result_fun_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:result_fun_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.result_fun_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:result_fun_t/1"},{"type":"type","title":"ExAequoColors.Colorizer.result_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:result_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.result_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:result_t/1"},{"type":"type","title":"ExAequoColors.Colorizer.rgx_pair/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:rgx_pair/0"},{"type":"type","title":"ExAequoColors.Colorizer.rgx_pairs/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:rgx_pairs/0"},{"type":"type","title":"ExAequoColors.Colorizer.stream_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:stream_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.zero_fn_t/0","doc":"","ref":"ExAequoColors.Colorizer.html#t:zero_fn_t/0"},{"type":"type","title":"ExAequoColors.Colorizer.zero_fn_t/1","doc":"","ref":"ExAequoColors.Colorizer.html#t:zero_fn_t/1"},{"type":"module","title":"ExAequoColors.Colorizer.Parser","doc":"Parses text and color definition chunks","ref":"ExAequoColors.Colorizer.Parser.html"},{"type":"function","title":"ExAequoColors.Colorizer.Parser.chunks_parser/1","doc":"","ref":"ExAequoColors.Colorizer.Parser.html#chunks_parser/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}